/*
------------------------------------------------------------
   Kobo Deluxe - An enhanced SDL port of XKobo
------------------------------------------------------------
 * Copyright (C) 2001, David Olofson
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	_KOBO_PREFS_H_
#define	_KOBO_PREFS_H_

#include "aconfig.h"

#define	MAX_CONFIG_LINES	1024

#include <stdio.h>

class prefs_t
{
	void print_switch(FILE *f, const char *base, int flag);
	int read_config(char ***cv, FILE *f);
  public:
	int	changed;	//Set when *edited* by the user
/*
FIXME: This should internally use some functions like
FIXME:		addswitch(const char *name, int &var);
FIXME: where "var" is an integer (boolean), and
FIXME:		addkey(const char *name, <type> &var);
FIXME: where "var" is an integer, float or 256 byte string.
FIXME: This is nice and safe for internal use inside a
FIXME: single instance of this class.
FIXME:
FIXME: I'm not sure about the access from outside, though.
FIXME: The current system is simple, but a "property" style
FIXME: (Delphi inspired) would be much more powerful.
FIXME: (Operator overloading would provide an interface very
FIXME: similar to the current one.)
*/
	int	use_joystick;

	int	fullscreen;
	int	videodriver;
	int	depth;		//Bits per pixel
	int	buffermode;
//	int	size;		//Integer scale factor
	int	width;		//Screen/window width
	int	height;		//Screen/window height
	int	internalres;	//Internal resolution for OpenGL modes
	int	scalemode;	//Scaling filter mode

	int	wait_msec;	//ms per control system frame
	int	filter;		//Use motion filtering

	int	cheat_mode;
	int	indicator;	//Enable collision testing mode

	int	sound;		//Enable sound
	int	samplerate;
	int	latency;	//Audio latency in ms
	int	volume;		//Audio volume
	int	reverb;		//Master reverb level
	int	threshold;	//Limiter threshold
	int	release;	//Limiter release rate
	int	use_ext_music;	//Use external playlist + data
	int	use_oss;	//Use OSS audio driver

	char	bgm_indexfile[258];	//Ext playlist path
	char	dir[258];		//Path to kobo-deluxe/
	char	gfxdir[258];		//Path to gfx/
	char	scoredir[258];		//Path to scores/

	prefs_t();
	~prefs_t();
	void set_defaults();
	int parse(int argc, char *argv[]);
	int read(FILE *f);
	int write(FILE *f);
};

#endif	//_KOBO_PREFS_H_
